<?php
// Die abstrakte Bauten-Klasse
class BaseConstruction extends BaseSimulator {
	// Tiefgang fuer z.B. Trockdocks
	private $draught = 0;

	// Konstruktor
	private function __construct ($class) {
		// Eltern-Konstrutor aufrufen
		parent::constructor($class);

		// Debug message
		if ((defined('DEBUG_CORE')) && (defined('DEBUG_CONSTRUCT'))) $this->getDebugInstance()->output(sprintf("[%s:] Konstruktor erreicht.<br />\n",
			$this->__toString()
		));

		// Beschreibung setzen
		$this->setPartDescr("Namenlose Landkonstruktion");

		// Etwas aufraeumen (brauchen wir hier nicht)
		$this->removeNumberFormaters();
	}

	// Konstruktor aufrufen
	public function constructor ($class) {
		$this->__construct($class);
	}

	// Tiefgang entfernen
	public function removeDraught () {
		if (defined('DEBUG_CORE')) $this->getDebugInstance()->output(sprintf("[%s:] Tiefgang wird entfernt.<br />\n",
			$this->__toString()
		));
		unset($this->draught);
	}
}

// [EOF]
?>
