<?php
// Super structures (renamed to UpperStructure to avoid mixing it with super classes
class BaseUpperStructure extends BaseStructure {
	/**
	 * Constructor for all super structures on a ship
	 */
	private function __construct ($class) {
		// Eltern-Konstruktor aufrufen
		parent::constructor($class);

		// Debug message
		if (((defined('DEBUG_STRUCTURE')) || (defined('DEBUG_ALL'))) && (defined('DEBUG_CONSTRUCT'))) {
			$this->getDebugInstance()->output(sprintf("[%s:%d] Konstruktor erreicht.<br />\n",
				__CLASS__,
				__LINE__
			));
		}

		// Beschreibung setzen
		$this->setPartDescr("Aufbauten");

		// Shall we clean up?
		if ($class == __CLASS__) {
			$this->removeSystemArray();
		}
	}

	/**
	 * Call new constructor
	 */
	function constructor ($class) {
		$this->__construct($class);
	}

	/**
	 * Creates an upper(=super) structure
	 */
	public static function createBaseUpperStructure () {
		// Instanz holen
		$upperInstance = new BaseUpperStructure (__CLASS__);

		// Debug message
		if ((defined('DEBUG_STRUCTURE')) || (defined('DEBUG_ALL'))) {
			$upperInstance->getDebugInstance()->output(sprintf("[%s:%d] Aufbauten wird konstruiert.<br />\n",
				__CLASS__,
				__LINE__
			));
		}

		// Unique-ID setzen
		$upperInstance->createUniqueID();

		// Return instance
		return $upperInstance;
	}

	/**
	 * Stub!
	 */
	public function saveObjectToDatabase () {
		$this->getDebugInstance()->output(sprintf("[%s:] Stub <strong>%s</strong> erreicht.",
			$this->__toString(),
			__FUNCTION__
		));
	}

	/**
	 * Limits this object with an ObjectLimits instance
	 */
	public function limitObject (ObjectLimits $limitInstance) {
		ApplicationEntryPoint::app_die("".__METHOD__." reached! Stub!");
	}
}

// [EOF]
?>
