<?php
// Auto-Deck
class CarDeck extends BaseDeck implements ItemIsTradeable, ConstructableShipPart {
	// Konstruktor
	private function __construct () {
		// Eltern-Konstruktor aufrufen
		parent::constructor(__CLASS__);

		// Debug message
		if (((defined('DEBUG_DECK')) || (defined('DEBUG_ALL'))) && (defined('DEBUG_CONSTRUCT'))) $this->getDebugInstance()->output(sprintf("[%s:%d] Konstruktor erreicht.<br />\n",
			__CLASS__,
			__LINE__
		));

		// Beschreibung setzen
		$this->setPartDescr("Autodeck");

		// Unique-ID erzeugen
		$this->createUniqueID();

		// Clean up a little
		$this->removeSystemArray();
	}

	// Autodeck erstellen
	public static function createCarDeck ($numDecks, $dim) {
		// Instanz holen
		$carInstance = new CarDeck();

		// Debug message
		if ((defined('DEBUG_DECK')) || (defined('DEBUG_ALL'))) $carInstance->getDebugInstance()->output(sprintf("[%s:%d] Ein Autodeck wird konstruiert...<br />\n",
			__CLASS__,
			__LINE__
		));

		// Abmasse extrahieren
		$carInstance->extractDimensions($dim);

		// Andere Daten uebetragen
		$carInstance->setNumDecks($numDecks);

		// Nicht noetige Instanz
		$carInstance->removePartInstance();

		// Instanz zurueckgeben
		return $carInstance;
	}

	// Deckanzahl entfernen
	public function removeNumDecks() {
		if ((defined('DEBUG_DECK')) || (defined('DEBUG_ALL'))) $this->getDebugInstance()->output(sprintf("[%s:%d] Anzahl Decks wurde gel&ouml;scht.<br />\n",
			__CLASS__,
			__LINE__
		));
		parent::removeNumDecks();
	}

	// Setter-Methode fuer Anzahl Decks
	public function setNumDecks($numDecks) {
		parent::setNumDecks($numDecks);
	}

	// Getter-Methode fuer Anzahl Decks
	public function getNumDecks() {
		return parent::getNumDecks();
	}

	// Overwritten method for tradeable items
	public function isTradeable () {
		return true;
	}

	/**
	 * Limits this object with an ObjectLimits instance
	 */
	public function limitObject (ObjectLimits $limitInstance) {
		ApplicationEntryPoint::app_die("".__METHOD__." reached! Stub!");
	}
}

// [EOF]
?>
