<?php
/**
 * An exception thrown when the returned directory resource is invalid
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0
 * @copyright	Copyright(c) 2007, 2008 Roland Haeder, this is free software
 * @license		GNU GPL 3.0 or any newer version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class InvalidDirectoryResourceException extends FrameworkException {
	/**
	 * The constructor
	 *
	 * @param		$message		Message from the exception
	 * @param		$code		Code number for the exception
	 * @return	void
	 */
	public final function __construct ($class, $code) {
		// Add a message around the missing class
		if (is_null($class)) {
			$message = "[???:] Ung&uuml;tige Verzeichnis-Resource.";
		} elseif (is_object($class)) {
			$message = sprintf("[%s:%d] Ung&uuml;tige Verzeichnis-Resource.",
				$class->__toString(),
				$this->getLine()
			);
		}

		// Call parent constructor
		parent::__construct($message, $code);
	}
}

// [EOF]
?>
